/* Boards/ARMulator/BoardDefines.h
Defines various constants and macros for the ARMulator

19/Feb/1999 ned
*/

/* KEEP CONSISTENT WITH BoardDefinesH.s */


/* Number of handlers for each exception */
#define UndefinedExcptHandlers	2
#define SWIExcptHandlers		2
#define PAbortExcptHandlers		2
#define DAbortExcptHandlers		2
#define IRQExcptHandlers		2
#define FIQExcptHandlers		2

/* Constants - Exception related */
#define ResetV	0
#define UndefV	1
#define SWIV	2
#define PAbortV	3
#define DAbortV	4
#define IRQV	6
#define FIQV	7

/*; Sizes of the processor mode stacks */
#define IRQ32StackSize		4096
#define FIQ32StackSize		1024
#define Abort32StackSize	1024
#define Undef32StackSize	1024
#define SVC32StackSize		8192
#define BOARD_TOTALSTKSSIZE	IRQ32StackSize + FIQ32StackSize + Abort32StackSize + Undef32StackSize + SVC32StackSize

/* Location of exception handlers */
#define BOARD_EXCEPTHLOCATION		0x0
/* Location of HAL r/w data */
#define BOARD_HALZPLOCATION			0xc0
/* Location of UART ctrl blks */
#define BOARD_HALZP_UARTSPACE		0x1000				/* 4k */
/* Location of L1 MMU page tables */
#define BOARD_ARMMMU_L1PAGETABLES	0x4000				/* 16k (16k of L1 page tables) */
/* Where we put the processor stacks */
#define BOARD_HALSTKSLOCATION		0x8000				/* 32k (16k) */

/* Locations of UART zero page locations */
#define HALZP_ANGELUARTSPACE		(0 * sizeof(HALUARTBlk))
#define HALZP_DEMONUARTSPACE		(1 * sizeof(HALUARTBlk))

/* This macro is called to return the location of the zero page memory
   NOTE: This gets called in the general ISR so make it quick!
   It returns a pointer to 64k of zero page memory in R0 */
#define BOARD_RETURNZPLOCATION() (HALZeroPage *)(0x00080000 - 0x10000)		/* 64k before mem end */

